﻿#include <iostream>
#include "CheckerBoard.h"
#include "CheckersAI.h"
#include <io.h>
#include <fcntl.h>

int main()
{
    _setmode(_fileno(stdout), _O_U16TEXT);

    CheckerBoard board = CheckerBoard::loadFromFile("board - Copy.checkers");

    board.print();

    wcout << "\n\n-----------\n\n";

    CheckersAI whiteAI(true);
    CheckersAI blackAI(false);

    bool whiteTurn = true;
    while (!board.isGameOver()) {
        wcout << L"\n\n";

        if (whiteTurn) {
            wcout << "White: ";
            CheckerBoard bestMove = whiteAI.findBestMove(board, 7);
            board.applyMove(bestMove);
        }
        /*else {
            wcout << "Black: ";
            CheckerBoard bestMove = blackAI.findBestMove(board, 7);
            board.applyMove(bestMove);
        }*/
        else
        {
            wcout << "Old pos: ";
            std::string inp;
            cin >> inp;
            CheckerPosition pos(inp);

            wcout << "New pos: ";
            std::string inp2;
            cin >> inp2;
            CheckerPosition newPos(inp2);

            auto& b = board;

            int dx = newPos.x - pos.x;
            int dy = newPos.y - pos.y;
            int cx = newPos.x + dx;
            int cy = newPos.y + dy;

            if (!b.isValidMove(pos, newPos, b.getCheckerAt(pos)) && !b.isValidCapture(pos, newPos, CheckerPosition(cx, cy), b.getCheckerAt(pos))) return -1;

            board.moveChecker(pos, newPos);
        }
        whiteTurn = !whiteTurn;
        board.print();
        //return 0;
    }

    wcout << L"Game over!\n";
}